#include <iostream>
#include <list>
#include <stdlib.h>

using namespace std;

typedef long long set_type;
list<set_type>	PrimeNumbers;
list<set_type>::iterator Prime;
const char* PrimeDat = "primes.txt";

//////////////////////////////////////////////////////////////////////
//
//	check if Number is prime
//
//////////////////////////////////////////////////////////////////////
bool
IsPrime ( set_type Number )
{
	list<set_type>::iterator Prime;
	set_type	PseudoRoot;
	char		LastDigit;

//	if (((char) Number % 10) == 5)
//		return (false);
	PseudoRoot = (Number / 2) + 1; // faster than sqrt and good enough
	for (Prime = PrimeNumbers.begin(); 
	    ((*Prime) < PseudoRoot) && (Prime != PrimeNumbers.end ());
	     Prime++)
	{
		if ((Number % (*Prime)) == 0)
			return false;
	}
	return (true);
} // IsPrime()
//////////////////////////////////////////////////////////////////////

int
main ( int argc, char* argv[] )
{
	set_type i, start, ende;
	bool do_print_now, do_print_summary;
	
	if (argc < 2)
	{
		cout << "syntax: " << argv[0] << " max [n|s]" << endl;
		cout << endl;
		cout << argv[0] << "max n  - will print out all primts directly"<< endl;
		cout << argv[0] << "max s  "
			<< "- will print out primaries after calculation is finished"
			<< endl;
		cout << "will calculate prime numbers in the range of ";
		cout << "2-max" << endl;
		cout << "maximum value for max is 2^64" << endl;
		return (-1);
	}
	do_print_now = false;
	do_print_summary = false;
	if (argc == 3)
	{
		if (argv[2][0] == 's')	do_print_summary = true;
		if (argv[2][0] == 'n')	do_print_now = true;
	}
	start = 7;
	ende  = atoll (argv[1]);
	PrimeNumbers.push_back(2);
	PrimeNumbers.push_back(3);
	PrimeNumbers.push_back (5);
	if (do_print_now)
	{
		cout << "2" << endl;
		cout << "3" << endl;
		cout << "5" << endl;
	}
	for (i=start; i<ende; i+=2)
	{
		if (IsPrime (i))
		{
			if (do_print_now)
				cout << i << endl;
			PrimeNumbers.push_back (i);
		}
	}
	if (do_print_summary)
	{
		for (Prime  = PrimeNumbers.begin();
			 Prime != PrimeNumbers.end();
			 Prime++)
			cout << *Prime << endl;
	}
	cout << PrimeNumbers.size() << " prims found." << endl;
}
